/* test0d.c - mouse (2) */

#include <mikeos.h>

/*
	used MikeOS API :-

	mikeos_mouse_disable
	mikeos_mouse_get_bt_press_info
	mikeos_mouse_get_bt_release_info
	mikeos_mouse_get_position
	mikeos_mouse_init
	mikeos_mouse_set_text_cursor
	mikeos_mouse_show
	mikeos_mouse_wait_for_l_click

	mikeos_check_for_key
	mikeos_clear_screen
	mikeos_pause
	mikeos_move_cursor
	mikeos_print_1hex
	mikeos_print_4hex
	mikeos_print_newline
	mikeos_print_space
	mikeos_print_string
*/

/* test os_mouse_get_position */
static	void	test_mouse_get_position(void)
{
	int		index, x_stack, y_stack, button, x, y;
	static	int	x_static, y_static;
	static	char	str0[] = "mikeos_mouse_get_position";
	static	char	str1[] = "press [ESC] to continue";

	index = 0;
	mikeos_clear_screen();
	mikeos_print_string(str0);
	mikeos_print_newline();
	mikeos_print_string(str1);

	do {
		if (index & 1) {
			button = mikeos_mouse_get_position(&x_static,
							   &y_static);
			x = x_static;
			y = y_static;
		} else {
			button = mikeos_mouse_get_position(&x_stack,
							   &y_stack);
			x = x_stack;
			y = y_stack;
		}

		mikeos_move_cursor(0, 10);

		mikeos_print_1hex(index & 1);
		mikeos_print_space();

		mikeos_print_4hex(button);
		mikeos_print_space();
		mikeos_print_4hex(x);
		mikeos_print_space();
		mikeos_print_4hex(y);
		mikeos_print_space();
		index++;

		mikeos_pause(500000UL);

	} while (mikeos_check_for_key() != 0x1b);

	return;
}

/* test os_mouse_get_bt_press_info */
static	void	test_mouse_get_bt_press_info(void)
{
	int		index, c_stack, x_stack, y_stack, button, c, x, y;
	static	int	c_static, x_static, y_static;
	static	char	str0[] = "mikeos_mouse_get_bt_press_info";
	static	char	str1[] = "press [Space] to continue";
	static	char	str2[] = "(use left button)";

	index = 0;
	mikeos_clear_screen();
	mikeos_print_string(str0);
	mikeos_print_newline();
	mikeos_print_string(str1);
	mikeos_print_newline();
	mikeos_print_string(str2);

	do {
		if (index & 1) {
			button = mikeos_mouse_get_bt_press_info(0,
								&c_static,
								&x_static,
								&y_static);
			c = c_static;
			x = x_static;
			y = y_static;
		} else {
			button = mikeos_mouse_get_bt_press_info(0,
							   &c_stack,
							   &x_stack,
							   &y_stack);
			c = c_stack;
			x = x_stack;
			y = y_stack;
		}

		mikeos_move_cursor(0, 11);

		mikeos_print_1hex(index & 1);
		mikeos_print_space();

		mikeos_print_4hex(button);
		mikeos_print_space();
		mikeos_print_4hex(c);
		mikeos_print_space();
		mikeos_print_4hex(x);
		mikeos_print_space();
		mikeos_print_4hex(y);
		mikeos_print_space();
		index++;

		mikeos_pause(500000UL);

	} while (mikeos_check_for_key() != 0x20);

	return;
}

/* test os_mouse_get_bt_release_info */
static	void	test_mouse_get_bt_release_info(void)
{
	int		index, c_stack, x_stack, y_stack, button, c, x, y;
	static	int	c_static, x_static, y_static;
	static	char	str0[] = "mikeos_mouse_get_bt_release_info";
	static	char	str1[] = "press [Esc] to continue";
	static	char	str2[] = "(use right button)";

	index = 0;
	mikeos_clear_screen();
	mikeos_print_string(str0);
	mikeos_print_newline();
	mikeos_print_string(str1);
	mikeos_print_newline();
	mikeos_print_string(str2);

	do {
		if (index & 1) {
			button = mikeos_mouse_get_bt_release_info(1,
								  &c_static,
								  &x_static,
								  &y_static);
			c = c_static;
			x = x_static;
			y = y_static;
		} else {
			button = mikeos_mouse_get_bt_release_info(1,
								  &c_stack,
								  &x_stack,
								  &y_stack);
			c = c_stack;
			x = x_stack;
			y = y_stack;
		}

		mikeos_move_cursor(0, 12);

		mikeos_print_1hex(index & 1);
		mikeos_print_space();

		mikeos_print_4hex(button);
		mikeos_print_space();
		mikeos_print_4hex(c);
		mikeos_print_space();
		mikeos_print_4hex(x);
		mikeos_print_space();
		mikeos_print_4hex(y);
		mikeos_print_space();
		index++;

		mikeos_pause(500000UL);

	} while (mikeos_check_for_key() != 0x1b);

	return;
}

/* test os_mouse_wait_for_l_click */
static	void	test_mouse_wait_for_l_click(void)
{
	int		index, x_stack, y_stack, x, y;
	static	int	x_static, y_static;
	static	char	str0[] = "mikeos_mouse_wait_for_l_click";
	static	char	str1[] = "press [Space] to continue";
	static	char	str2[] = "(use left button)";

	index = 0;
	mikeos_clear_screen();
	mikeos_print_string(str0);
	mikeos_print_newline();
	mikeos_print_string(str1);
	mikeos_print_newline();
	mikeos_print_string(str2);

	do {
		if (index & 1) {
			mikeos_mouse_wait_for_l_click(&x_static, &y_static);
			x = x_static;
			y = y_static;
		} else {
			mikeos_mouse_wait_for_l_click(&x_stack, &y_stack);
			x = x_stack;
			y = y_stack;
		}

		mikeos_move_cursor(0, 13);

		mikeos_print_1hex(index & 1);
		mikeos_print_space();

		mikeos_print_4hex(x);
		mikeos_print_space();
		mikeos_print_4hex(y);
		mikeos_print_space();
		index++;

		mikeos_pause(500000UL);

	} while (mikeos_check_for_key() != 0x20);

	return;
}

int	MikeMain(void *arg)
{
	mikeos_mouse_init(NULL);
	mikeos_mouse_set_text_cursor(0xffff, 0xff00);
	mikeos_mouse_show();

	test_mouse_get_position();
	test_mouse_get_bt_press_info();
	test_mouse_get_bt_release_info();
	test_mouse_wait_for_l_click();

	mikeos_mouse_disable();
	mikeos_print_newline();

	return 0;
}
